
<div class='main'>
  <div id='term_wrap'>
    <div id='term_container'>
    </div>
  </div>
</div>

<script type='text/javascript'>
  /*
   * Test of the Core API
   */

  const termGeometry = {width: 80, height: 24};
  const term = new Term({
    cols: termGeometry.width, rows: termGeometry.height,
    scrollback: 10000, fontSize: 12 });

  function termHandler(str) {
    for (const c of str)
      LupBookVM.Core.consoleQueue(c.charCodeAt(0));
  };

  window.onload = (e) => {
    term.open(document.getElementById('term_container'));

    term.write('Loading VM...\r\n');
    term.setKeyHandler(termHandler);

    LupBookVM.Client.boot({
      consoleWriteDebug: (str) => term.write(str),
      consoleGeometryDebug: () => {
        const [w, h] = term.getSize();
        return { width : w, height : h};
      }
    })
      .then(() => console.log('VM Init complete!'))
      .catch((err) => console.log('VM Error: ' + err))
  };
</script>
